.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

MakeRecentFiles proto

;**********************************************************************************************************

IDP_MENU        equ 200
IDM_OPEN         equ 201
IDM_CLOSE        equ 202
IDM_RECENT       equ 203    ;*
IDM_EXIT         equ 219

WIN_WIDTH       equ 320
WIN_HEIGHT      equ 240

;**********************************************************************************************************

.data
ClassName   db "WinClass",0
AppName     db "Recent",0

recent      db "&Recent Files",0
f1          db "file1",0
f2          db "file2",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hMenu       HMENU       ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    push edi
    lea edi,[wc]
    assume edi:ptr WNDCLASSEX
    mov [edi].cbSize,SIZEOF wc
    mov [edi].style,CS_HREDRAW or CS_VREDRAW
    mov [edi].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [edi].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [edi].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [edi].hCursor,eax
    mov [edi].hbrBackground,COLOR_WINDOW+1
    mov [edi].lpszClassName,OFFSET ClassName
    xor eax,eax
    mov [edi].cbClsExtra,eax
    mov [edi].cbWndExtra,eax
    mov [edi].lpszMenuName,eax
    mov [edi].hIconSm,eax
    invoke LoadMenu, hInstance,IDP_MENU
    mov hMenu,eax
    invoke RegisterClassEx, edi
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,hMenu,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea edi,[msg]
        assume edi:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, edi,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, edi
            invoke DispatchMessage, edi
        .ENDW
        mov eax,[edi].wParam
    .ENDIF
    assume edi:nothing
    pop edi
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_COMMAND --------------------------------------------------------------------------------------
    .IF (eax==WM_COMMAND)
        ;lParam is hWndCtl
        mov eax,wParam
        mov edx,eax
        and eax,0ffffh      ;item/control/accel ID
        shr edx,16          ;notification code (0=menu; 1=accelerator)
        .IF (eax==IDM_EXIT)
            invoke PostMessage, hwnd,WM_CLOSE,NULL,NULL
        .ENDIF
;-- WM_SIZE -----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SIZE)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;width
        shr edx,16      ;height
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke MakeRecentFiles
;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

MakeRecentFiles proc
    LOCAL hSubMenu:DWORD
    LOCAL hChildMenu:DWORD

;-- create a new popup menu to be inserted
    invoke CreatePopupMenu
    mov hChildMenu,eax

;-- add some filenames into the new popup menu
    invoke AppendMenu, hChildMenu,MF_STRING,1,ADDR f1
    invoke AppendMenu, hChildMenu,MF_STRING,2,ADDR f2

;-- get handle of "File" menu
    invoke GetSubMenu, hMenu,0
    mov hSubMenu,eax

;-- insert the "Recent Files" menu as a popup into the "File" menu
    invoke InsertMenu, hSubMenu,2,MF_BYPOSITION or MF_POPUP or MF_STRING,hChildMenu,ADDR recent

    ret
MakeRecentFiles endp

end start
